;;; Errno constant definitions.
;;; Copyright (c) 1993 by Olin Shivers.

;;; These are the correct values for a Harris NightHawk running CX/UX

(define-syntax define-errnos
  (syntax-rules ()
    ((define-errnos form ...)
     (begin (define-enum-constant "errno" . form) ...))))

(define errno/2big 7) ; 2big is not a legit Scheme symbol. Lose, lose.

(define-errnos
  (perm                  1)
  (noent                 2)
  (srch                  3)
  (intr                  4)
  (io                    5)
  (nxio                  6)
;  (2big                  7)
  (noexec                8)
  (badf                  9)
  (child                10)
  (again                11)
  (nomem                12)
  (acces                13)
  (fault                14)
  (notblk               15)
  (busy                 16)
  (exist                17)
  (xdev                 18)
  (nodev                19)
  (notdir               20)
  (isdir                21)
  (inval                22)
  (nfile                23)
  (mfile                24)
  (notty                25)
  (fbig                 27)
  (nospc                28)
  (spipe                29)
  (rofs                 30)
  (mlink                31)
  (pipe                 32)
  (dom                  33)
  (range                34)
  (nomsg                35)
  (idrm                 36)
  (deadlk               45)
  (nolck                46)
  (nametoolong          78)
  (nosys                89)
  (notempty            158)
  (txtbsy               26)
  (chrng                37)
  (l2nsync              38)
  (l3hlt                39)
  (l3rst                40)
  (lnrng                41)
  (unatch               42)
  (nocsi                43)
  (l2hlt                44)
  (bade                 50)
  (badr                 51)
  (xfull                52)
  (noano                53)
  (badrqc               54)
  (badslt               55)
  (deadlock             56)
  (bfont                57)
  (nostr                60)
  (nodata               61)
  (time                 62)
  (nosr                 63)
  (nonet                64)
  (nopkg                65)
  (remote               66)
  (nolink               67)
  (adv                  68)
  (srmnt                69)
  (comm                 70)
  (proto                71)
  (multihop             74)
  (dotdot               76)
  (badmsg               77)
  (notuniq              80)
  (badfd                81)
  (remchg               82)
  (libacc               83)
  (libbad               84)
  (libscn               85)
  (libmax               86)
  (libexec              87)
  (loop                 90)
  (restart              91)
  (inprogress          128)
  (already             129)
  (notsock             130)
  (destaddrreq         131)
  (msgsize             132)
  (prototype           133)
  (noprotoopt          134)
  (protonosupport      135)
  (socktnosupport      136)
  (opnotsupp           137)
  (pfnosupport         138)
  (afnosupport         139)
  (addrinuse           140)
  (addrnotavail        141)
  (netdown             142)
  (netunreach          143)
  (netreset            144)
  (connaborted         145)
  (connreset           146)
  (nobufs              147)
  (isconn              148)
  (notconn             149)
  (shutdown            150)
  (toomanyrefs         151)
  (timedout            152)
  (connrefused         153)
  (hostdown            156)
  (hostunreach         157)
  (proclim             159)
  (users               160)
  (dquot               161)
  (stale               162)
  (powerfail           163)
  (chnrst              256)
  (xlnerr              257)
  (xnfst               258)
  (xforbid             259)
  (xcancel             260)
  (xcollin             261)
  (xnone               262)
  (xaratt              263)
  (xbadcom             264)
  (xbadpac             265)
  (xbadpar             266)
  (xbadstate           267)
  (xbadwin             268)
  (xdwas               269)
  (xexmax              270)
  (xlncon              271)
  (xlnop               272)
  (xlobnd              273)
  (xmulrq              274)
  (xnatt               275)
  (xnofac              276)
  (xnres               277)
  (xrdexcd             278)
  (xtmout              279)
  (xwover              280)
  (xcaclr              281)
  (xrange              282)
  (lnkdwn              283)
  (reopen              284)
  (reclos              285)
  (rtryex              286)
  (lnkrst              287)
  (lidle               288)
  (idlestop            289)
  (bufok               290)
  (rembsy              293)
  (xnoact              294)
  (xbadfac             295)
  (buflow              296)
  (verr                297)
  (xmit                298)
  (vovrfl              299)
  (badcmp              300)
  (sdopen              301)
  (sdkbuf              302)
  (sdpu                303)
  (sdaddr              304)
  (sdfrsize            305)
  (sdencode            306)
  (pubuf               307)
  (puappl              308)
  (puludown            309)
  (luinit              310)
  (lupudown            311)
  (lubuf               312)
  (lupubad             313)
  (iocancel            314)
  (areq                315)
  (nrlock              316)
  (ndatreg             317)
  (pagnv               318)
  (badspace            319)
  (regstale            320)
  (norfmode            321)
  (adstatavail         322)
  (adnostatavail       323)
  (adnotconfigured     324)
  (adlinkstarted       325)
  (strpipe             330)
  (mtimers             340)
  (fail                341)
  (notsup              342))
